/*
Autor  : Piotr Zielinski
Zadanie: Turniej
*/

#include <stdio.h>
#include <string.h>

const int N=200;

char win[N][256];
char inpath[N];

int forward[N], backward[N];
int frn, bckn;
int path[N];
int pathn;
int n;

void Compute(FILE *fin, FILE *fout) {
	memset(inpath, 0, sizeof(inpath));
	fscanf(fin, "%i", &n);
	for(int i=0;i<long(n)*(n-1)/2;i++) {
		int a,b;
		fscanf(fin, "%i %i", &a, &b);a--;b--;
		win[a][b]=1;
		win[b][a]=0;
	}
	forward[0]=backward[0]=0;
	inpath[0]=1;

	for(frn=1;;frn++) {
		int t=forward[frn-1];
		for(int i=0;i<n;i++)
			if (!inpath[i] && win[t][i]) break;
		if (i>=n) break;
		forward[frn]=i;
		inpath[i]=1;
	}

	for(bckn=1;;bckn++) {
		int t=backward[bckn-1];
		for(int i=0;i<n;i++)
			if (!inpath[i] && win[i][t]) break;
		if (i>=n) break;
		backward[bckn]=i;
		inpath[i]=1;
	}

	for(i=0;i<bckn;i++)
		path[i]=backward[bckn-i-1];
	for(i=0;i<frn-1;i++)
		path[i+bckn]=forward[i+1];
	pathn=bckn+frn-1;

	for(i=0;i<n;i++)
		if (!inpath[i]) {
			for(int j=0;j<pathn-1;j++)
				if (win[path[j]][i] && win[i][path[j+1]]) break;
			for(int k=pathn-1;k>j;k--)
				path[k+1]=path[k];
			path[j+1]=i;
			pathn++;
		}

	for(i=0;i<pathn;i++)
		fprintf(fout,"%i ",path[i]+1);
	fprintf(fout,"\n");
}



int main(void) {
	FILE *fin = fopen("turniej.in","rt");
	FILE *fout = fopen("turniej.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}