/*
Autor  : Piotr Zielinski
Zadanie: Rozklad jazdy tramwajow
*/

#include <stdio.h>
#include <stdlib.h>

const int N=10010;
int n;
int m;

int numbers[N];

int Comp(const void *a, const void *b) {
	return *(int*)a - *(int*)b;
}

void Compute(FILE *fin, FILE *fout) {
	fscanf(fin, "%i %i", &n, &m);

	int suma=0;
	numbers[0]=0;
	for(int i=1;i<n;i++) {
		int time;
		fscanf(fin, "%*i %i", &time);
		suma += time;
		if (suma >= m) suma-=m;
		numbers[i]=suma;
	}

	qsort(numbers, n, sizeof(numbers[0]), Comp);
	numbers[n]=numbers[0]+m;
	int max=0;
	for(i=0;i<n;i++)
		if (numbers[i+1]-numbers[i]>max) max = numbers[i+1]-numbers[i];

	fprintf(fout, "%i\n", m-max);
}

int main(void) {
	FILE *fin = fopen("rozklad.in","rt");
	FILE *fout = fopen("rozklad.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}