/*
Autor  : Piotr Zielinski
Zadanie: Ciag binarny
*/

#include <stdio.h>
#include <string.h>

char cycle[1010];
int pytno[1010];

int k,m;

long n;

void Compute(FILE *fin, FILE *fout) {
	fscanf(fin,"%i %li %i",&k, &n, &m);n--;
	fscanf(fin,"%s", cycle);

	pytno[0]=0;
	for(int i=0;i<k;i++)
		if (cycle[i]=='?') pytno[i+1]=pytno[i]+1;
			else pytno[i+1]=pytno[i];

	for(i=0;i<m;i++) {
		long pos = n+i;

		for(;;) {
			int posmod = pos % k;
			if (cycle[posmod]!='?') {
				fputc(cycle[posmod], fout);
				break;
			}
			pos = pos / k * pytno[k] + pytno[posmod];
		}
	}
	fputc('\n', fout);
}

int main(void) {
	FILE *fin = fopen("ciag.in","rt");
	FILE *fout = fopen("ciag.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}