/*
Autor  : Piotr Zielinski
Zadanie: Turniej (sprawdzanie poprawnosci)
*/

#include <stdio.h>
#include <string.h>

const int N=200;

int n;
char win[N][256];
char was[N];

int Compute(FILE *fin, FILE *fout) {
	fscanf(fin, "%i", &n);
	for(int i=0;i<long(n)*(n-1)/2;i++) {
		int a,b;
		fscanf(fin, "%i %i", &a, &b);a--;b--;
		win[a][b]=1;
		win[b][a]=0;
	}

	memset(was,0,sizeof(was));

	int last=-1;

	for(i=0; i<n; i++) {
		int v;
		if (fscanf(fout, "%i", &v) <= 0) return 1;
		v--;
		if (v<0 || v>=n) return 1;
		if (was[v]) return 1;
		was[v]=1;
		if (last>=0 && !win[last][v]) return 1;
		last = v;
	}

	return 0;
}

int main(void) {
	FILE *fin = fopen("turniej.in","rt");
	FILE *fout = fopen("turniej.out","rt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		if (Compute(fin, fout)) return 1;

	if (fscanf(fout, "%i", &d) > 0) return 1;

	fclose(fin);
	fclose(fout);

	printf("\nOK!");

	return 0;
}