/*
Autor  : Piotr Zielinski
Zadanie: Diamenty
*/

#include <stdio.h>
#include <string.h>

int maxdiam[10][16];
int maxdiam2[10][16];

int n,m,t;

struct {
	int x,y;
} jump[5] = {{0,0},{0,1},{0,-1},{1,0},{-1,0}};

void Compute(FILE *fin, FILE *fout) {
	fscanf(fin,"%i %i %i",&n, &m, &t);

	memset(maxdiam,0, sizeof(maxdiam));

	for(int i=0;i<t;i++) {
		int nn, mm;
		fscanf(fin, "%i %i", &nn, &mm);nn--;mm--;
		maxdiam[nn][mm]++;
		for(nn=0;nn<n;nn++)
			for(mm=0;mm<m;mm++) {
				int max=0;
				for(int j=0;j<5;j++) {
					int xn = nn + jump[j].x;
					int ym = mm + jump[j].y;
					if ((unsigned)xn < n && (unsigned)ym < m && max<maxdiam[xn][ym])
						max = maxdiam[xn][ym];
				}
				maxdiam2[nn][mm]=max;
			}
		memcpy(maxdiam, maxdiam2, sizeof(maxdiam));
	}

	int max=0;
	for(i=0;i<n;i++)
		for(int j=0;j<m;j++)
			if (maxdiam[i][j]>max) max=maxdiam[i][j];

	fprintf(fout, "%i\n", max);
}

int main(void) {
	FILE *fin = fopen("diamenty.in","rt");
	FILE *fout = fopen("diamenty.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}